org.eclipse.viatra.integration.uml.derivedfeatures

## Class StateIsCompositeMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<StateIsCompositeMatch>
    - - org.eclipse.viatra.integration.uml.derivedfeatures.StateIsCompositeMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<StateIsCompositeMatch>

      public class StateIsCompositeMatcher
      extends BaseMatcher<StateIsCompositeMatch>

  Generated pattern matcher API of the org.eclipse.viatra.integration.uml.derivedfeatures.stateIsComposite pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `StateIsCompositeMatch`.

  Original source: ``

       (region- >notEmpty())

        @Surrogate(feature = "isComposite")
        @QueryExplorer(checked = false)
       pattern stateIsComposite(
           self : State, isComposite
       ) {
           find stateIsComposite_0(self, _region);
           isComposite == true;
       } or {
           neg find stateIsComposite_0(self, _region);
           isComposite == false;
       }

  See Also:
    `StateIsCompositeMatch`, `StateIsCompositeProcessor`, `StateIsCompositeQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected StateIsCompositeMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected StateIsCompositeMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(org.eclipse.uml2.uml.State pSelf, java.lang.Boolean pIsComposite)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static StateIsCompositeMatcher` | `create()`
    `void` | `forEachMatch(org.eclipse.uml2.uml.State pSelf, java.lang.Boolean pIsComposite, IMatchProcessor<? super StateIsCompositeMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(org.eclipse.uml2.uml.State pSelf, java.lang.Boolean pIsComposite, IMatchProcessor<? super StateIsCompositeMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<StateIsCompositeMatch>` | `getAllMatches(org.eclipse.uml2.uml.State pSelf, java.lang.Boolean pIsComposite)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<java.lang.Boolean>` | `getAllValuesOfisComposite()` Retrieve the set of values that occur in matches for isComposite.
    `java.util.Set<java.lang.Boolean>` | `getAllValuesOfisComposite(org.eclipse.uml2.uml.State pSelf)` Retrieve the set of values that occur in matches for isComposite.
    `java.util.Set<java.lang.Boolean>` | `getAllValuesOfisComposite(StateIsCompositeMatch partialMatch)` Retrieve the set of values that occur in matches for isComposite.
    `java.util.Set<org.eclipse.uml2.uml.State>` | `getAllValuesOfself()` Retrieve the set of values that occur in matches for self.
    `java.util.Set<org.eclipse.uml2.uml.State>` | `getAllValuesOfself(java.lang.Boolean pIsComposite)` Retrieve the set of values that occur in matches for self.
    `java.util.Set<org.eclipse.uml2.uml.State>` | `getAllValuesOfself(StateIsCompositeMatch partialMatch)` Retrieve the set of values that occur in matches for self.
    `StateIsCompositeMatch` | `getOneArbitraryMatch(org.eclipse.uml2.uml.State pSelf, java.lang.Boolean pIsComposite)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(org.eclipse.uml2.uml.State pSelf, java.lang.Boolean pIsComposite)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `StateIsCompositeMatch` | `newMatch(org.eclipse.uml2.uml.State pSelf, java.lang.Boolean pIsComposite)` Returns a new (partial) match.
    `static StateIsCompositeMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<StateIsCompositeMatcher>` | `querySpecification()`
    `protected java.util.Set<java.lang.Boolean>` | `rawAccumulateAllValuesOfisComposite(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for isComposite.
    `protected java.util.Set<org.eclipse.uml2.uml.State>` | `rawAccumulateAllValuesOfself(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for self.
    `protected StateIsCompositeMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static StateIsCompositeMatcher on(ViatraQueryEngine engine)
                                            throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static StateIsCompositeMatcher create()
                                                throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<StateIsCompositeMatch> getAllMatches(org.eclipse.uml2.uml.State pSelf,
                                                                           java.lang.Boolean pIsComposite)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pSelf` - the fixed value of pattern parameter self, or null if not bound.
        `pIsComposite` - the fixed value of pattern parameter isComposite, or null if not bound.
      Returns:
        matches represented as a StateIsCompositeMatch object.

    - #### getOneArbitraryMatch

          public StateIsCompositeMatch getOneArbitraryMatch(org.eclipse.uml2.uml.State pSelf,
                                                            java.lang.Boolean pIsComposite)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pSelf` - the fixed value of pattern parameter self, or null if not bound.
        `pIsComposite` - the fixed value of pattern parameter isComposite, or null if not bound.
      Returns:
        a match represented as a StateIsCompositeMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(org.eclipse.uml2.uml.State pSelf,
                                  java.lang.Boolean pIsComposite)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pSelf` - the fixed value of pattern parameter self, or null if not bound.
        `pIsComposite` - the fixed value of pattern parameter isComposite, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(org.eclipse.uml2.uml.State pSelf,
                                  java.lang.Boolean pIsComposite)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pSelf` - the fixed value of pattern parameter self, or null if not bound.
        `pIsComposite` - the fixed value of pattern parameter isComposite, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(org.eclipse.uml2.uml.State pSelf,
                                   java.lang.Boolean pIsComposite,
                                   IMatchProcessor<? super StateIsCompositeMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pSelf` - the fixed value of pattern parameter self, or null if not bound.
        `pIsComposite` - the fixed value of pattern parameter isComposite, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(org.eclipse.uml2.uml.State pSelf,
                                              java.lang.Boolean pIsComposite,
                                              IMatchProcessor<? super StateIsCompositeMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pSelf` - the fixed value of pattern parameter self, or null if not bound.
        `pIsComposite` - the fixed value of pattern parameter isComposite, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public StateIsCompositeMatch newMatch(org.eclipse.uml2.uml.State pSelf,
                                                java.lang.Boolean pIsComposite)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pSelf` - the fixed value of pattern parameter self, or null if not bound.
        `pIsComposite` - the fixed value of pattern parameter isComposite, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOfself

          protected java.util.Set<org.eclipse.uml2.uml.State> rawAccumulateAllValuesOfself(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for self.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfself

          public java.util.Set<org.eclipse.uml2.uml.State> getAllValuesOfself()

      Retrieve the set of values that occur in matches for self.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfself

          public java.util.Set<org.eclipse.uml2.uml.State> getAllValuesOfself(StateIsCompositeMatch partialMatch)

      Retrieve the set of values that occur in matches for self.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfself

          public java.util.Set<org.eclipse.uml2.uml.State> getAllValuesOfself(java.lang.Boolean pIsComposite)

      Retrieve the set of values that occur in matches for self.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### rawAccumulateAllValuesOfisComposite

          protected java.util.Set<java.lang.Boolean> rawAccumulateAllValuesOfisComposite(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for isComposite.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfisComposite

          public java.util.Set<java.lang.Boolean> getAllValuesOfisComposite()

      Retrieve the set of values that occur in matches for isComposite.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfisComposite

          public java.util.Set<java.lang.Boolean> getAllValuesOfisComposite(StateIsCompositeMatch partialMatch)

      Retrieve the set of values that occur in matches for isComposite.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfisComposite

          public java.util.Set<java.lang.Boolean> getAllValuesOfisComposite(org.eclipse.uml2.uml.State pSelf)

      Retrieve the set of values that occur in matches for isComposite.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected StateIsCompositeMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<StateIsCompositeMatch>`

    - #### arrayToMatch

          protected StateIsCompositeMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<StateIsCompositeMatch>`

    - #### arrayToMatchMutable

          protected StateIsCompositeMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<StateIsCompositeMatch>`

    - #### querySpecification

          public static IQuerySpecification<StateIsCompositeMatcher> querySpecification()
                                                                                 throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded